@@ -46,9 +46,9 @@ STEXI
ETEXI
DEF("dd", img_dd,
- "dd [--image-opts] [-f fmt] [-O output_fmt] [bs=block_size] [count=blocks] [skip=blocks] [conv=notrunc] if=input of=output")
+ "dd [--image-opts] [-f fmt] [-O output_fmt] [bs=block_size] [count=blocks] [skip=blocks] [seek=blocks] [conv=notrunc] if=input of=output")
STEXI
-@item dd [--image-opts] [-f @var{fmt}] [-O @var{output_fmt}] [bs=@var{block_size}] [count=@var{blocks}] [skip=@var{blocks}] [conv=notrunc] if=@var{input} of=@var{output}
+ @item dd [--image-opts] [-f @var{fmt}] [-O @var{output_fmt}] [bs=@var{block_size}] [count=@var{blocks}] [skip=@var{blocks}] [seek=@var{blocks}] [conv=notrunc] if=@var{input} of=@var{output}
ETEXI
DEF("info", img_info,
@@ -175,6 +175,7 @@ static void QEMU_NORETURN help(void)
" 'if=FILE' read from FILE\n"
" 'of=FILE' write to FILE\n"
" 'skip=N' skip N bs-sized blocks at the start of input\n"
+ " 'seek=N' seek N bs-sized blocks at the start of output\n"
" 'conv=notrunc' do not truncate the output file\n";
printf("%s\nSupported formats:", help_msg);
@@ -3808,7 +3809,8 @@ out:
#define C_IF 04
#define C_OF 010
#define C_SKIP 020
-#define C_CONV 040
+#define C_SEEK 040
+#define C_CONV 0100
struct DdInfo {
unsigned int flags;
@@ -3897,6 +3899,22 @@ static int img_dd_skip(const char *arg,
return 0;
}
+static int img_dd_seek(const char *arg,
+ struct DdIo *in, struct DdIo *out,
+ struct DdInfo *dd)
+{
+ char *end;
+
+ out->offset = qemu_strtosz_suffix(arg, &end, QEMU_STRTOSZ_DEFSUFFIX_B);
+
+ if (out->offset < 0 || *end) {
+ error_report("invalid number: '%s'", arg);
+ return 1;
+ }
+
+ return 0;
+}
+
#define C_NOTRUNC 01
static int img_dd_conv(const char *arg,
@@ -3927,7 +3945,7 @@ static int img_dd(int argc, char **argv)
const char *out_fmt = "raw";
const char *fmt = NULL;
const char *out_filename;
- int64_t size = 0, out_size;
+ int64_t size = 0, out_size = 0;
int64_t block_count = 0, out_pos, in_pos;
struct DdInfo dd = {
.flags = 0,
@@ -3953,6 +3971,7 @@ static int img_dd(int argc, char **argv)
{ "if", img_dd_if, C_IF },
{ "of", img_dd_of, C_OF },
{ "skip", img_dd_skip, C_SKIP },
+ { "seek", img_dd_seek, C_SEEK },
{ "conv", img_dd_conv, C_CONV },
{ NULL, NULL, 0 }
};
@@ -4019,6 +4038,14 @@ static int img_dd(int argc, char **argv)
arg = NULL;
}
+ /* Overflow check for seek */
+ if (out.offset > INT64_MAX / out.bsz) {
+ error_report("seek with the block size specified is too large "
+ "for data type used");
+ ret = -1;
+ goto out;
+ }
+
if (!(dd.flags & C_IF && dd.flags & C_OF)) {
error_report("Must specify both input and output files");
ret = -1;
@@ -4044,9 +4071,9 @@ static int img_dd(int argc, char **argv)
}
/* Overflow means the specified offset is beyond input image's size */
if (in.offset > INT64_MAX / in.bsz || size < in.offset * in.bsz) {
- out_size = 0;
+ out_size = out.offset * out.bsz;
} else {
- out_size = size - in.offset * in.bsz;
+ out_size = size - in.offset * in.bsz + out.offset * out.bsz;
}
out_filename = out.filename;
@@ -4132,10 +4159,12 @@ static int img_dd(int argc, char **argv)
goto out;
}
- if (in.offset <= INT64_MAX / in.bsz && size >= in.offset * in.bsz) {
- if (blk2sz < out_size) {
- blk_truncate(blk2, out_size);
+ if (in.offset > INT64_MAX / in.bsz || size < in.offset * in.bsz) {
+ if (blk2sz < out.offset * out.bsz) {
+ blk_truncate(blk2, out.offset * out.bsz);
}
+ } else if (blk2sz < out_size) {
+ blk_truncate(blk2, out_size);
}
}
@@ -4152,7 +4181,7 @@ static int img_dd(int argc, char **argv)
in.buf = g_new(uint8_t, in.bsz);
- for (out_pos = 0; in_pos < size; block_count++) {
+ for (out_pos = out.offset * out.bsz; in_pos < size; block_count++) {
int in_ret, out_ret;
if (in_pos + in.bsz > size) {
@@ -154,6 +154,8 @@ sets the output file. dd truncates the output file to zero if 'conv=notrunc'
is not specified.
@item skip=@var{blocks}
sets the number of input blocks to skip
+@item seek=@var{blocks}
+sets the number of output blocks to skip
@item conv=notrunc
makes dd not truncate output file to zero
@end table
@@ -329,7 +331,7 @@ skipped. This is useful for formats such as @code{rbd} if the target
volume has already been created with site specific options that cannot
be supplied through qemu-img.
-@item dd [-f @var{fmt}] [-O @var{output_fmt}] [bs=@var{block_size}] [count=@var{blocks}] [skip=@var{blocks}] [conv=notrunc] if=@var{input} of=@var{output}
+@item dd [-f @var{fmt}] [-O @var{output_fmt}] [bs=@var{block_size}] [count=@var{blocks}] [skip=@var{blocks}] [seek=@var{blocks}] [conv=notrunc] if=@var{input} of=@var{output}
Dd copies from @var{input} file to @var{output} file converting it from
@var{fmt} format to @var{output_fmt} format.
new file mode 100755
@@ -0,0 +1,73 @@
+#! /bin/bash
+#
+# qemu-img dd test for the seek option
+#
+# Copyright (C) 2016 Reda Sallahi
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+#
+
+owner=fullmanet@gmail.com
+
+seq="$(basename $0)"
+echo "QA output created by $seq"
+
+here="$PWD"
+status=1
+
+_cleanup()
+{
+ _cleanup_test_img
+ rm -f "$TEST_IMG.out" "$TEST_IMG.out.dd"
+}
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+. ./common.rc
+. ./common.filter
+. ./common.pattern
+
+_supported_fmt raw
+_supported_proto file
+_supported_os Linux
+
+TEST_SEEK_BLOCKS="1 2 30 30K"
+
+for seek in $TEST_SEEK_BLOCKS; do
+ echo
+ echo "== Creating image =="
+
+ size=1M
+ _make_test_img $size
+ _check_test_img
+ $QEMU_IO -c "write -P 0xa 13k 512k" "$TEST_IMG" | _filter_qemu_io
+
+ echo
+ echo "== Converting the image with dd with seek=$seek =="
+
+ $QEMU_IMG dd if="$TEST_IMG" of="$TEST_IMG.out" seek="$seek" conv=notrunc \
+ -O "$IMGFMT" 2> /dev/null
+ TEST_IMG="$TEST_IMG.out" _check_test_img
+ dd if="$TEST_IMG" of="$TEST_IMG.out.dd" seek="$seek" conv=notrunc \
+ status=none
+
+ echo
+ echo "== Compare the images with qemu-img compare =="
+
+ $QEMU_IMG compare "$TEST_IMG.out.dd" "$TEST_IMG.out"
+done
+
+echo
+echo "*** done"
+rm -f "$seq.full"
+status=0
new file mode 100644
@@ -0,0 +1,51 @@
+QA output created by 161
+
+== Creating image ==
+Formatting 'TEST_DIR/t.IMGFMT', fmt=IMGFMT size=1048576
+No errors were found on the image.
+wrote 524288/524288 bytes at offset 13312
+512 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+
+== Converting the image with dd with seek=1 ==
+No errors were found on the image.
+
+== Compare the images with qemu-img compare ==
+Images are identical.
+
+== Creating image ==
+Formatting 'TEST_DIR/t.IMGFMT', fmt=IMGFMT size=1048576
+No errors were found on the image.
+wrote 524288/524288 bytes at offset 13312
+512 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+
+== Converting the image with dd with seek=2 ==
+No errors were found on the image.
+
+== Compare the images with qemu-img compare ==
+Images are identical.
+
+== Creating image ==
+Formatting 'TEST_DIR/t.IMGFMT', fmt=IMGFMT size=1048576
+No errors were found on the image.
+wrote 524288/524288 bytes at offset 13312
+512 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+
+== Converting the image with dd with seek=30 ==
+No errors were found on the image.
+
+== Compare the images with qemu-img compare ==
+Images are identical.
+
+== Creating image ==
+Formatting 'TEST_DIR/t.IMGFMT', fmt=IMGFMT size=1048576
+No errors were found on the image.
+wrote 524288/524288 bytes at offset 13312
+512 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+
+== Converting the image with dd with seek=30K ==
+No errors were found on the image.
+
+== Compare the images with qemu-img compare ==
+Images are identical.
+
+*** done
@@ -160,4 +160,5 @@
158 rw auto quick
159 rw auto quick
160 rw auto quick
+161 rw auto quick
162 auto quick